class L_Systems_Class{
 String axiom = "X";
 
 //Mimosa Tree with leaves
 String [][] mt_rules = {{"F", "FF", "F", "F", "F"},
                      {"X", "F[+XZ][-XZ]", "F[+XZ][-XZ]", "F[+XZ][-XZ]", "F[+XZ][-XZ][FXZ]"},
                      {"Z", "M+L--L+M+L--L+M+L--L+M+L--L+M+L--L+M+L--L+MB", "M+L--L+M+L--L+M+L--L+M+L--L+M+L--L+M+L--L", "M+L--L+M+L--L+M+L--L+M+L--L+M+L--L+M+L--L+", "M+L--L+M+L--L+M+L--L+M+L--L+M+L--L+M+L--L+"},
                      {"-","-","-","-","-"},
                      {"+","+","+","+","+"},
                      {"[", "[", "[", "[", "["},
                      {"]", "]", "]", "]", "]"}};
                      
  //Mimosa Tree with large leaves                    
  String [][] mtb_rules = {{"F", "FF", "F", "F", "F"},
                      {"X", "F[+Xl][-Xl]", "F[+Xl][-Xl]", "F[+Xl][-Xl]", "F[+X][-X][FXl]"},
                      {"-","-","-","-","-"},
                      {"+","+","+","+","+"},
                      {"[", "[", "[", "[", "["},
                      {"]", "]", "]", "]", "]"}};
                      
 //Pomagranate Bush                    
 String [][] pb_rules = {{"F", "F[+++F]FFF[-F]F[+FZ+Z--Z+]", "F[++F]F[---FF+Z--Z+]F[+F]FY", "F[+F]F[-F]FZ+Z-", "F[+F]F[-F]FY"},
                      {"X","[+++F][---F][++F][--F][+F][-F]F","[+++F][---F][++F][--F][+F][-F]F","[+++F][---F][++F][--F][+F][-F]F","[+++F][---F][++F][--F][+F][-F]F","[+++F][---F][++F][--F][+F][-F]F",},
                      {"Y", "[+FL][-FL]FY", "FF[+FF]F[-F]FZ", "FF[++F][+F]F[-FFZ+Z--Z+]FP", "FF[+FL]FF[-F]FFZ"},
                      {"Z", "S+L-S-L+SS+L--L+", "S+L-S-L+SS+L--L+", "S+L-S-L+SS+L--L+", "S+L-S-L+SS+L--L+"},
                      {"-","-","-","-","-"},
                      {"+","+","+","+","+"},
                      {"[", "[", "[", "[", "["},
                      {"]", "]", "]", "]", "]"}};
                      
 //Rose plant                    
  String [][] rules = {{"F", "F", "F", "F", "F"},
                      {"X", "FKMKM[+XK][-XK]", "MKMMK[+XK][-XK]U", "[-XK]KF[+XK][-XK]", "KFKMK[+XK][-XK][KFXK]"},
                      {"K", "[M+R--R+M+R--R+MR]","[M+R--R+M+R--R+MR]","[M+R--R+M+R--R+MR]","[M+R--R+M+R--R+MR]"},
                      {"-","-","-","-","-"},
                      {"+","+","+","+","+"},
                      {"[", "[", "[", "[", "["},
                      {"]", "]", "]", "]", "]"}};
                      
 // Testing leaf branch                      
 String [][] tl_rules = {{"Z", "M+R--R+M+R--R+MR","M+R--R+M+R--R+MR","M+R--R+M+R--R+MR","M+R--R+M+R--R+MR"},
                      {"-","-","-","-","-"},
                      {"+","+","+","+","+"},
                      {"[", "[", "[", "[", "["},
                      {"]", "]", "]", "]", "]"}};
                      
                      
 String computedWord;
 int iter = 1;
 float size;
 float angle;
 float scale;
 
 L_Systems_Class(float size, float angle, float scale){
   this.size = size;
   this.angle = angle;
   this.scale = scale;
   computedWord = axiom;
   
 }
 
 void iteration(){
   char s;
   String newWord = "";
   size = size*scale;
    for (int i=0; i<computedWord.length(); i++){
      s = computedWord.charAt(i);
      for (int j=0; j<rules.length; j++){
        if (s == rules[j][0].charAt(0)){
           newWord = newWord + rules[j][(int)random(1,5)];
          break;
         }
      }
    }
    iter++;
    computedWord = newWord;
    //println(iter +": "+ computedWord);  
 }
 
 void drawLSystem(Turtle t){
   char s;
   float loop_iter = 1;
   for (int i=0; i<computedWord.length(); i++){
     s = computedWord.charAt(i);
     if (s == 'F'){
       stroke(#301a0c);
       //stroke(#030000);
       //stroke weight set for different variations of the mimosa tree
       //strokeWeight(16/loop_iter+2);
       t.forward(size);
       //loop_iter = loop_iter + 0.2;
       //strokeWeight(18);
     }else if (s == 'S'){
       stroke(#301a0c);
       t.forward(size);
     }else if (s == 'M'){
       stroke(#301a0c);
       t.forward(size/8);
     }else if (s == '-'){
        t.left(angle+random(-10,10));
     }else if (s == '+'){
        t.right(angle+random(-10,10));
     }else if (s == '['){
        t.push();
     }else if (s == ']'){
        t.pop();
     }else if (s == 'L'){
        noStroke();
        drawLeaf(t.getX(), t.getY(), t.getHeading());
        stroke(0);
        noFill();
     }else if (s == 'R'){
        noStroke();
        drawRoseLeaf(t.getX(), t.getY(), t.getHeading());
        stroke(0);
        noFill();
     }else if (s == 'l'){
        noStroke();
        drawBigLeaf(t.getX(), t.getY(), t.getHeading());
        stroke(0);
        noFill();
     }else if (s == 'B'){
        noStroke();
        drawBloom(t.getX(), t.getY());
        stroke(0);
        noFill();
     }else if (s == 'U'){
        noStroke();
        drawRoseBloom(t.getX(), t.getY());
        stroke(0);
        noFill();
     }else if (s == 'P'){
       noStroke();
       int pom = (int)random(0,15);
        if (pom == 2){
          fill(156, 14, 14);
          drawPomagranate(t.getX(), t.getY());
        } else {
          drawLeaf(t.getX(), t.getY(), t.getHeading());
        }
        stroke(0);
        noFill();
     }
   }
 }
 
 void drawPomagranate(float x, float y) {
  int radius = 25;
  float red = 156;
  float blue = 14;
  float green = 14;
  for (int r = radius; r > 0; --r) {
    fill(red, blue, green);
    ellipse(x, y, r, r);
    blue = blue + 1.5;
    
  }
  fill(255, 172, 156);
  ellipse(x+5, y-2, 2, 3);
}

 void drawLeaf(float x, float y, float h) {
  float colors [][] = {{82,157,72},
              {5, 108, 32}, 
              {201, 242, 165}, 
              {65, 144, 51}, 
              {62, 146, 42}};
   int shade =  (int)random(0,4);
   fill(colors[shade][0], colors[shade][1], colors[shade][2]);
   strokeWeight(3);
   if(h < 0){
     translate(x - 2.5,y);
     rotate(radians(h));
     ellipse(0, 0, 5, 14);
     rotate(radians(360-h));
     translate(-x + 2.5,-y);
   
   }else{
     translate(x + 2.5,y);
     rotate(radians(h));
     ellipse(0, 0, 5, 14);
     rotate(radians(360-h));
     translate(-x - 2.5,-y);  
   }
}

void drawBigLeaf(float x, float y, float h) {
  //float colors [][] = {{82,157,72},
  //            {5, 108, 32}, 
  //            {201, 242, 165}, 
  //            {65, 144, 51}, 
  //            {62, 146, 42}};
   //int shade =  (int)random(0,4);
   //fill(colors[shade][0], colors[shade][1], colors[shade][2]);
   fill(0,0,0);
   strokeWeight(3);
   if(h < 0){
     translate(x - 25,y);
     rotate(radians(h));
     ellipse(0, 0, 50, 100);
     rotate(radians(360-h));
     translate(-x + 25,-y);
   
   }else{
     translate(x + 25,y);
     rotate(radians(h));
     ellipse(0, 0, 50, 100);
     rotate(radians(360-h));
     translate(-x - 25,-y);  
   }
}

 void drawBloom(float x, float y) {
  int radius = 10;
  float red = 252;
  float blue = 121;
  float green = 169;
  for (int r = radius; r > 0; r-=2) {
    fill(red, blue, green);
    ellipse(x, y, r, r);
    green = green + 30;
    blue = blue + 30;
    
  }
}

void drawRoseBloom(float x, float y) {
  int radius = 25;
  float red = 235;
  float blue = 14;
  float green = 110;
  for (int r = radius; r > 0; r-=5) {
    fill(red, blue, green);
    ellipse(x, y, r, r);
    red = red + 5;
    green = green - 30;
    blue = blue + 30;
    
  }
}

void drawRoseLeaf(float x, float y, float h){
  float colors [][] = {{82,157,72},
              {5, 108, 32}, 
              {201, 242, 165}, 
              {65, 144, 51}, 
              {62, 146, 42}};
   int shade =  (int)random(0,4);
   fill(colors[shade][0], colors[shade][1], colors[shade][2]);
   strokeWeight(3);
   if(h < 0){
     translate(x - 2.5,y);
     rotate(radians(h));
     beginShape();
     vertex(0, 0);
     vertex(0+3.5, 0-8.5);
     vertex(0+5, 0-15);
     vertex(0+3.5, 0-23.5);
     vertex(0, 0-30);
     vertex(0-8.5, 0-33.5);
     vertex(0-15, 0-35);
     vertex(0-23.5, 0-33.5);
     vertex(0-31, 0-31);
     vertex(0-33.5, 0-23.5);
     vertex(0-35, 0-15);
     vertex(0-33.5, 0-8.5);
     vertex(0-30, 0);
     vertex(0-23.5, 0+3.5);
     vertex(0-15, 0+5);
     vertex(0-8.5, 0+3.5);
     endShape(CLOSE);
     rotate(radians(360-h));
     translate(-x + 2.5,-y);
   
   }else{
     translate(x + 2.5,y);
     rotate(radians(h));
     beginShape();
     vertex(0, 0);
     vertex(0-3.5, 0-8.5);
     vertex(0-5, 0-15);
     vertex(0-3.5, 0-23.5);
     vertex(0, 0-30);
     vertex(0+8.5, 0-33.5);
     vertex(0+15, 0-35);
     vertex(0+23.5, 0-33.5);
     vertex(0+31, 0-31);
     vertex(0+33.5, 0-23.5);
     vertex(0+35, 0-15);
     vertex(0+33.5, 0-8.5);
     vertex(0+30, 0);
     vertex(0+23.5, 0+3.5);
     vertex(0+15, 0+5);
     vertex(0+8.5, 0+3.5);
     endShape(CLOSE);
     rotate(radians(360-h));
     translate(-x - 2.5,-y);  
   }
}
 
}
